package android.HW2;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.AdapterView.OnItemSelectedListener;

public class MemoPad extends Activity {
    /** Called when the activity is first created. */
//    @Override
    private Button save, del;
    private EditText titleText, noteText;
    private Spinner spinner;
    private ArrayAdapter<CharSequence> titleArray;
    private ArrayAdapter<CharSequence> noteArray;
    private Builder alertNoTitle, alertDel, alertBadDel;
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        spinner = (Spinner) findViewById(R.id.Spinner_Select);
        save = (Button) findViewById(R.id.Button_Save);
        del = (Button) findViewById(R.id.Button_Del);
        titleText = (EditText) findViewById(R.id.EditText_Title);
        noteText = (EditText) findViewById (R.id.EditText_Notes);
        titleArray = new ArrayAdapter<CharSequence>(this, android.R.layout.simple_spinner_item);
        noteArray = new ArrayAdapter<CharSequence>(this, android.R.layout.simple_spinner_dropdown_item);
        titleArray.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        noteArray.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner.setAdapter(titleArray);
        alertNoTitle = new AlertDialog.Builder(MemoPad.this)
        .setTitle("HW2 Err...")
        .setMessage("Title must be non-empty string!")
        .setNeutralButton("OK", new DialogInterface.OnClickListener() {
        	public void onClick(DialogInterface dialog, int whichButton) {
        		;
        	}
        });
        alertDel = new AlertDialog.Builder(MemoPad.this)
        .setTitle("HW2 Delete?")
        .setIcon(android.R.drawable.ic_delete)
        .setMessage("Are you sure you want to delete?")
        .setPositiveButton("Yes", new DialogInterface.OnClickListener() {
        	public void onClick(DialogInterface dialog, int whichButton) {
        		delSpinnerItem();
        	}
        })
        .setNegativeButton("No", new DialogInterface.OnClickListener() {
        	public void onClick(DialogInterface dialog, int whichButton) {
        		;
        	}
        });
        alertBadDel = new AlertDialog.Builder(MemoPad.this)
        .setTitle("HW2 Err...")
        .setMessage("Cannot delete this entry!")
        .setNeutralButton("OK", new DialogInterface.OnClickListener() {
        	public void onClick(DialogInterface dialog, int whichButton) {
        		;
        	}
        });
        titleArray.add("New...");
        noteArray.add("");
        spinner.setOnItemSelectedListener(new OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parent, View v, int position, long id) {
				// TODO Auto-generated method stub
				ldSpinnerItem();
			}

			public void onNothingSelected(AdapterView<?> parent) {
				// TODO Auto-generated method stub
				ldSpinnerItem();
			}
        });
        save.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		addNewSpinnerItem();
        	}
        });
        del.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		alertDel.show();
        	}
        });
    }
    private void addNewSpinnerItem() {
    	if (!titleText.getText().toString().equals("")) {
    		if (titleArray.getPosition(titleText.getText().toString()) > 0) {
    			int index = titleArray.getPosition(titleText.getText().toString());
    			noteArray.remove(noteArray.getItem(index));
    			noteArray.insert(noteText.getText().toString(), index);
    		} else {
    			CharSequence textHolder = "" + titleText.getText();
    			titleArray.add(textHolder);
    			textHolder = "" + noteText.getText();
    			noteArray.add(textHolder);
    			spinner.setSelection(noteArray.getCount()-1);
    		}
    	} else {
            alertNoTitle.show();
       	}
    }
    private void delSpinnerItem() {
    	if (spinner.getSelectedItemPosition() != 0) {
    		int index = spinner.getSelectedItemPosition();
    		titleArray.remove(titleArray.getItem(index));
    		noteArray.remove(noteArray.getItem(index));
    		spinner.setSelection(0);
    	} else {
    		alertBadDel.show();
    	}
    }
    private void ldSpinnerItem() {
    	if (spinner.getSelectedItemPosition() == 0)
    		titleText.setText("");
    	else
    		titleText.setText(titleArray.getItem(spinner.getSelectedItemPosition()));
        noteText.setText(noteArray.getItem(spinner.getSelectedItemPosition()));
    }
}